/******************************************************************************
* Include files
******************************************************************************/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include <math.h>

#include "calculator.h"
#include "lcd.h"
/******************************************************************************
* Macros
******************************************************************************/


/******************************************************************************
* Constants
******************************************************************************/


/******************************************************************************
* Global Variables
******************************************************************************/
volatile uint8_t state=BLANK;
volatile uint8_t pushed_button=NONE;
char write_string[100]={};

char first_num_string[5]={0,0,0,0,0};
volatile int32_t first_num_value=0;
volatile uint8_t first_num_cnt=0;

char second_num_string[5]={0,0,0,0,0};
volatile int32_t second_num_value=0;
volatile uint8_t second_num_cnt=0;
volatile uint8_t muvelet=0;

volatile uint32_t result_value=0;

/******************************************************************************
* External Variables
******************************************************************************/


/******************************************************************************
* Local Function Declarations
******************************************************************************/
void calculator_state_machine(uint8_t button);

/******************************************************************************
* Local Function Definitions
******************************************************************************/
/******************************************************************************
* Function:			void calculator_state_machine(uint8_t button)
* Description:		Szmolgp llapotgp
* Input:
* Output:
* Notes:
******************************************************************************/
void calculator_state_machine(uint8_t button)
{
	if(button>=NULLA && button <=KILENC)
	{
		if (state==RESULT)
		{
			lcd_clrdisplay();
		}
		if(muvelet==0) state=FIRST_NUM;
		else state=SECOND_NUM;
		
	}
	if(button>=OSSZEADAS && button<=OSZTAS && state==FIRST_NUM) state=OPERAND;
	if(button==EGYENLOSEGJEL && first_num_cnt!=0 && second_num_cnt!=0) state=RESULT;

	

	switch(state)
	{
		case FIRST_NUM:
		{
			if(first_num_cnt<4)
			{
				lcd_set_address(first_num_cnt);
				sprintf(write_string,"%d",button);
				lcdreir(write_string);
				first_num_string[first_num_cnt]=button+48;
				first_num_cnt++;
			}
			
			break;
		}
		case SECOND_NUM:
		{
			if(second_num_cnt<4)
			{
				lcd_set_address(second_num_cnt+5);
				sprintf(write_string,"%d",button);
				lcdreir(write_string);
				second_num_string[second_num_cnt]=button+48;
				second_num_cnt++;
			}
			break;
		}
		case OPERAND:
		{
			switch(button)
			{
				case OSSZEADAS:
				{
					lcdreir("+");
					break;
				}
				case KIVONAS:
				{
					lcdreir("-");
					break;
				}
				case SZORZAS:
				{
					lcdreir("x");
					break;
				}
				case OSZTAS:
				{
					lcdreir("/");
					break;
				}
			}
			muvelet=button;
			break;
		}
		case RESULT:
		{
			sscanf(first_num_string,"%ld",&first_num_value);
			sscanf(second_num_string,"%ld", &second_num_value);

			
			switch(muvelet)
			{
				case OSSZEADAS:
				{
					lcd_set_address(40);
					sprintf(write_string,"=%ld",first_num_value+second_num_value);
					lcdreir(write_string);
					break;
				}
				case KIVONAS:
				{
					lcd_set_address(40);
					sprintf(write_string,"=%ld",(first_num_value-second_num_value));
					lcdreir(write_string);
					break;
				}
				case SZORZAS:
				{	
					lcd_set_address(40);
					sprintf(write_string,"=%ld",first_num_value*second_num_value);
					lcdreir(write_string);
					break;
				}
				case OSZTAS:
				{
					lcd_set_address(40);
					volatile float value=(float)((float)first_num_value/(float)second_num_value);
					volatile int16_t d1=(int16_t)value;
					volatile float f1=((float)value)-d1;
					volatile uint16_t d2 = f1*10000;

					sprintf(write_string,"=%d.%04d", d1, d2);
					lcdreir(write_string);
					break;
				}
			}
			first_num_cnt=0;
			second_num_cnt=0;
			first_num_value=0;
			second_num_value=0;
			for(uint8_t i=0; i<4; i++)
			{
				first_num_string[i]=0;
				second_num_string[i]=0;
			}
			muvelet=0;
			break;
		}
	}
}

/******************************************************************************
* Global Function Definitions
******************************************************************************/
/******************************************************************************
* Function:			void button_check_task(void)
* Description:		Gomblenyoms ellenrzs task
* Input:
* Output:
* Notes:
******************************************************************************/
void button_check_task(void)
{
	
	if(!(PIND & (1<<PD0))) pushed_button=TIZEDESJEL;
	if(pushed_button==TIZEDESJEL && (PIND & (1<<PD0)))
	{
		calculator_state_machine(TIZEDESJEL);
		pushed_button=NONE;
	}

	if(!(PIND & (1<<PD1))) pushed_button=NULLA;
	if(pushed_button==NULLA && (PIND & (1<<PD1)))
	{
		calculator_state_machine(NULLA);
		pushed_button=NONE;
	}

	if(!(PIND & (1<<PD2))) pushed_button=EGYENLOSEGJEL;
	if(pushed_button==EGYENLOSEGJEL && (PIND & (1<<PD2)))
	{
		calculator_state_machine(EGYENLOSEGJEL);
		pushed_button=NONE;
	}

	if(!(PIND & (1<<PD3))) pushed_button=OSZTAS;
	if(pushed_button==OSZTAS && (PIND & (1<<PD3)))
	{
		calculator_state_machine(OSZTAS);
		pushed_button=NONE;
	}

	if(!(PINE & (1<<PE3))) pushed_button=SZORZAS;
	if(pushed_button==SZORZAS && (PINE & (1<<PE3)))
	{
		calculator_state_machine(SZORZAS);
		pushed_button=NONE;
	}

	if(!(PINE & (1<<PE2))) pushed_button=EGY;
	if(pushed_button==EGY && (PINE & (1<<PE2)))
	{
		calculator_state_machine(EGY);
		pushed_button=NONE;
	}

	if(!(PINE & (1<<PE1))) pushed_button=KETTO;
	if(pushed_button==KETTO && (PINE & (1<<PE1)))
	{
		calculator_state_machine(KETTO);
		pushed_button=NONE;
	}

	if(!(PINE & (1<<PE0))) pushed_button=HAROM;
	if(pushed_button==HAROM && (PINE & (1<<PE0)))
	{
		calculator_state_machine(HAROM);
		pushed_button=NONE;
	}

	if(!(PINF & (1<<PF3))) pushed_button=KIVONAS;
	if(pushed_button==KIVONAS && (PINF & (1<<PF3)))
	{
		calculator_state_machine(KIVONAS);
		pushed_button=NONE;
	}

	if(!(PINF & (1<<PF2))) pushed_button=NEGY;
	if(pushed_button==NEGY && (PINF & (1<<PF2)))
	{
		calculator_state_machine(NEGY);
		pushed_button=NONE;
	}

	if(!(PINF & (1<<PF1))) pushed_button=OT;
	if(pushed_button==OT && (PINF & (1<<PF1)))
	{
		calculator_state_machine(OT);
		pushed_button=NONE;
	}

	if(!(PINF & (1<<PF0))) pushed_button=HAT;
	if(pushed_button==HAT && (PINF & (1<<PF0)))
	{
		calculator_state_machine(HAT);
		pushed_button=NONE;
	}

	if(!(PING & (1<<PG3))) pushed_button=OSSZEADAS;
	if(pushed_button==OSSZEADAS && (PING & (1<<PG3)))
	{
		calculator_state_machine(OSSZEADAS);
		pushed_button=NONE;
	}

	if(!(PING & (1<<PG2))) pushed_button=HET;
	if(pushed_button==HET && (PING & (1<<PG2)))
	{
		calculator_state_machine(HET);
		pushed_button=NONE;
	}

	if(!(PING & (1<<PG1))) pushed_button=NYOLC;
	if(pushed_button==NYOLC && (PING & (1<<PG1)))
	{
		calculator_state_machine(NYOLC);
		pushed_button=NONE;
	}

	if(!(PING & (1<<PG0))) pushed_button=KILENC;
	if(pushed_button==KILENC && (PING & (1<<PG0)))
	{
		calculator_state_machine(KILENC);
		pushed_button=NONE;
	}
}