/******************************************************************************
* Ksztette: Fehr rpd
* Dtum 2016. szeptember 19
* Board: BIGAVR6
* Lers: Szmolgp
******************************************************************************/
/******************************************************************************
* Include files
******************************************************************************/
#include <avr/io.h>
#include <inttypes.h>
#include <avr/interrupt.h>


#include "lcd.h"
#include "timer.h"
#include "calculator.h"

/******************************************************************************
* Macros
******************************************************************************/

/******************************************************************************
* Constants
******************************************************************************/


/******************************************************************************
* Global Variables
******************************************************************************/
extern volatile uint8_t timer_5ms,timer_10ms,timer_25ms,timer_100ms,timer_1000ms;


/******************************************************************************
* External Variables
******************************************************************************/


/******************************************************************************
* Local Function Declarations
******************************************************************************/
void port_init(void);

/******************************************************************************
* Local Function Definitions
******************************************************************************/
void port_init(void)
{
	DDRA=0x00;
	DDRB=0x00;
	DDRC=0x00;
	PORTA=0x00;
	PORTB=0x00;
	PORTC=0x00;
	DDRD = (0<<PD3) | (0<<PD2) | (0<<PD1) | (0<<PD0);
	PORTD = (1<<PD3) | (1<<PD2) | (1<<PD1) | (1<<PD0);

	DDRE = (0<<PE3) | (0<<PE2) | (0<<PE1) | (0<<PE0);
	PORTE = (1<<PE3) | (1<<PE2) | (1<<PE1) | (1<<PE0);

	DDRF = (0<<PF3) | (0<<PF2) | (0<<PF1) | (0<<PF0);
	PORTF = (1<<PF3) | (1<<PF2) | (1<<PF1) | (1<<PF0);

	DDRG = (0<<PG3) | (0<<PG2) | (0<<PG1) | (0<<PG0);
	PORTG = (1<<PG3) | (1<<PG2) | (1<<PG1) | (1<<PG0);
}


int main(void)
{
	port_init();
	lcdinit();
	TIMER0_Init();
	sei();

	while(1)
	{

		if(timer_5ms)
		{
			
			timer_5ms=FALSE;
		}
		
		if(timer_10ms)
		{
			
			timer_10ms=FALSE;
		}
		
		if(timer_25ms)
		{
			timer_25ms=FALSE;
		}
		
		if(timer_100ms)
		{
			button_check_task();
			timer_100ms=FALSE;
		}
		
		if(timer_1000ms)
		{

			timer_1000ms=FALSE;
		}
		
	}
}

