/******************************************************************************
* Include files
******************************************************************************/
#include <avr/io.h>
#include <avr/interrupt.h>
#include "timer.h"

/******************************************************************************
* Macros
******************************************************************************/


/******************************************************************************
* Constants
******************************************************************************/


/******************************************************************************
* Global Variables
******************************************************************************/
uint16_t Cnt=0;

/******************************************************************************
* External Variables
******************************************************************************/
volatile uint8_t timer_5ms,timer_10ms,timer_25ms,timer_100ms,timer_1000ms;

/******************************************************************************
* Local Function Declarations
******************************************************************************/


/******************************************************************************
* Local Function Definitions
******************************************************************************/


/******************************************************************************
* Global Function Definitions
******************************************************************************/

/******************************************************************************
* Function:         void TIMER0_Init(void)
* Description:		timer inicializlsa
* Input:
* Output:
* Notes:
******************************************************************************/
void TIMER0_Init(void)
{
	//use TIMER0
	//        D7    D6    D5     D4    D3    D2   D1   D0
	//TCCR0A: FOC0A WGM00 COM0A1 CM0A0 WGM01 CS02 CS01 CS00
	//        0     0     0      0     1     0    1    1
	//CTC mode
	
	TCCR0A= (1<<WGM01) | (1<<CS01) | (1<<CS00);
	OCR0A=125; // 1ms
	TIMSK0 = TIMSK0 | (1 << OCIE0A);
}


/******************************************************************************
* Interrupt Routines
******************************************************************************/

/******************************************************************************
* Function:			ISR(TIMER0_COMP_vect)
* Description:		Timer0 Output Compare megszakts
* Input:
* Output:
* Notes:
******************************************************************************/
ISR(TIMER0_COMP_vect)
{
	if(!(Cnt % 5))
	{
		timer_5ms=TRUE;
	}
	if(!(Cnt % 10))
	{
		timer_10ms=TRUE;
	}
	if(!(Cnt % 25))
	{
		timer_25ms=TRUE;
	}
	if(!(Cnt % 100))
	{
		timer_100ms=TRUE;
	}
	if(!(Cnt % 1000))
	{
		timer_1000ms=TRUE;
	}

	Cnt++;
}